GLM: Geometric functions

GLM 0.9.5

- Main Page
- Related Pages
- Modules
- Namespaces
- Files

Functions
Geometric functions
GLM Core

## Functions
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec3< T, P > | cross (detail::tvec3< T, P > const &x, detail::tvec3< T, P > const &y)
template<typename genType >
GLM_FUNC_DECL genType::value_type | distance (genType const &p0, genType const &p1)
template<typename T , precision P, template< typename, precision > class vecType>
GLM_FUNC_DECL T | dot (vecType< T, P > const &x, vecType< T, P > const &y)
template<typename genType >
GLM_FUNC_DECL genType | dot (genType const &x, genType const &y)
template<typename genType >
GLM_FUNC_DECL genType | faceforward (genType const &N, genType const &I, genType const &Nref)
template<typename genType >
GLM_FUNC_DECL genType::value_type | length (genType const &x)
template<typename genType >
GLM_FUNC_DECL genType | normalize (genType const &x)
template<typename genType >
GLM_FUNC_DECL genType | reflect (genType const &I, genType const &N)
template<typename T , precision P, template< typename, precision > class vecType>
GLM_FUNC_DECL vecType< T, P > | refract (vecType< T, P > const &I, vecType< T, P > const &N, T const &eta)

## Detailed Description

These operate on vectors as vectors, not component-wise.

## Function Documentation

GLM_FUNC_DECL detail::tvec3<T, P> glm::cross | ( | detail::tvec3< T, P > const & | x,
|  | detail::tvec3< T, P > const & | y
| ) |  |

Returns the cross product of x and y.

Template Parameters

  valType | Floating-point scalar types.

See Also
  GLSL cross man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL genType::value_type glm::distance | ( | genType const & | p0,
|  | genType const & | p1
| ) |  |

Returns the distance betwwen p0 and p1, i.e., length(p0 - p1).

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL distance man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL T glm::dot | ( | vecType< T, P > const & | x,
|  | vecType< T, P > const & | y
| ) |  |

Returns the dot product of x and y, i.e., result = x * y.

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL dot man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL genType glm::dot | ( | genType const & | x,
|  | genType const & | y
| ) |  |

Returns the dot product of x and y, i.e., result = x * y.

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL dot man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL genType glm::faceforward | ( | genType const & | N,
|  | genType const & | I,
|  | genType const & | Nref
| ) |  |

If dot(Nref, I) < 0.0, return N, otherwise, return -N.

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL faceforward man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL genType::value_type glm::length | ( | genType const & | x | ) |

Returns the length of x, i.e., sqrt(x * x).

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL length man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL genType glm::normalize | ( | genType const & | x | ) |

Returns a vector in the same direction as x but with length of 1.

See Also
  GLSL normalize man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL genType glm::reflect | ( | genType const & | I,
|  | genType const & | N
| ) |  |

For the incident vector I and surface orientation N, returns the reflection direction : result = I - 2.0 * dot(N, I) * N.

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL reflect man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

GLM_FUNC_DECL vecType<T, P> glm::refract | ( | vecType< T, P > const & | I,
|  | vecType< T, P > const & | N,
|  | T const & | eta
| ) |  |

For the incident vector I and surface normal N, and the ratio of indices of refraction eta, return the refraction vector.

Template Parameters

  genType | Floating-point vector types.

See Also
  GLSL refract man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions